

--definitely don't change these things:
local mod_path
if BeeMovie and BeeMovie.GetPath then 
	mod_path = BeeMovie:GetPath()
else
	mod_path = ModPath
end
BeeMovie = BeeMovie or {}

--probably don't change these things:
BeeMovie.logs_enabled = false
BeeMovie.to_log = false --if true, logs to BLT log/console
BeeMovie.lines = {}
BeeMovie.disabled = false
BeeMovie.output_desired = false --activated in-gamed
BeeMovie.prefix_log = "[Bee Movie]: " --only used for error logging

--you can change the rest of these things: 
BeeMovie._input_path = tostring(mod_path) .. "beescripts/script.txt"
BeeMovie.starting_line = 1
BeeMovie.current_line = BeeMovie.starting_line --incremented automatically
BeeMovie.message_interval = 1 --seconds between messages
BeeMovie.prefix = "{Bee Movie} " --this will appear in all bee movie related chat messages, and is used to prevent script output from triggering the activation/deactivation phrases. DO NOT USE SQUARE BRACKETS. (This causes the prefix to be recognized as a custom pattern instead)
--for activation/deactivation phrases: keywords are not case-sensitive, and punctuation/space characters are filtered out.
BeeMovie.buzzwords = { --activation
	"bee",
	"buzz",
	"jazz",
	"honey",
	"flower",
	"pollen",
	"barry",
	"benson",
	"black and yellow",
	"yellow and black",
	"pollination",
	"tournament of roses",
	"rose",
	"insect",
	"queen",
	"bug",
	"honeycomb",
	"Jerry",
	"Seinfeld",
	"bloom",
	"hexagon",
	"honex",
	"sting",
	"dance"
}
BeeMovie.bearwords = { --deactivation
	"stop",
	"cancel",
	"quit",
	"bear",
	"rain",
	"i hate bees",
	"bees suck",
	"Layton T. Montgomery did nothing wrong",
	"Layton Montgomery did nothing wrong",
	"Layton T. Montgomery",
	"Layton Montgomery",
	"wasps are cool",
	"I like wasps",
	"wasps are better",
	"I\'m allergic to bees",
	"smoke",
	"tennis",
	"varroa",
	"mites",
	"pesticide",
	"toxicoscordion",
	"spathodea",
	"ochroma",
	"buckeye",
	"raid",
	"colony collapse disorder",
	"artificial sweetener",
	"bee movie was bad",
	"I hate Bee Movie",
	"I hated Bee Movie",
	"Bee Movie sucks",
	"Bee Movie sucked",
	"fuck Bee Movie",
	"it\'s hip to fuck bees",
	"Jerry Seinfeld isn\'t funny",
	"Kramer",
	"unbee",
	"rolled-up newspaper",
	"shoe",
	"begone",
	"beegone",
	"fly away",
	"buzz off",
	"bee'n\'t"
}
BeeMovie.rude_responses = { --spoken when someone says "fuck" in addition to a deactivation phrase (provided that "fuck" is not part of the deactivation phrase)
	"Why is yogurt night so difficult?!",
	"My nerves are fried from riding on this emotional roller coaster!",
	"When will this nightmare end?!"
}

--$WORD is replaced by the activation or deactivation phrase
BeeMovie.deactivation_response = "Alright, someone said \"$WORD\", I'm outta here." 
BeeMovie.activation_response = "Did someone say \"$WORD\"?!" -- $WORD will be capitalized. to change this, edit chatmanager.lua

---------------------------------------------------------------------------
--if you're just doing a shallow edit (swapping out the script + keywords),
--then you shouldn't need to edit anything below this line
---------------------------------------------------------------------------

function BeeMovie:IsDisabled()
	return self.disabled
end

function BeeMovie:Load()
--	local file = io.open(, "r")
		--if you're wondering why i did it this way, it's because the bee movie script is 4.5k lines long, including the empty newlines which i did not remove
	for line in io.lines(self._input_path) do
		if line and (line ~= "") and (line ~= "\n") then 
			table.insert(self.lines,line)
			if self.to_log then 
				self:Log(line)
			end
		end
	end
	self:Log("Script file not found. You hear something?  Like tiny screaming?")
end

function BeeMovie:GetMessageInterval()
	return self.message_interval
end

function BeeMovie:Start()
	self.output_desired = true
	local delayed_calls = DelayedCallsFix or DelayedCalls
	delayed_calls:Add("bee_movie_output",self:GetMessageInterval(), callback(self,self,"DoOutput"))	
end

function BeeMovie:Stop()
	local delayed_calls = DelayedCallsFix or DelayedCalls
	delayed_calls:Remove("bee_movie_output")
	self.output_desired = false
end

function BeeMovie:Log(s,params)
	if not self.logs_enabled then 
		return
	end
	if Console then 
		Console:Log(s,params)
	else
		log(tostring(self.prefix_log) .. tostring(s))
	end
end

function BeeMovie:Toggle(state)
	if state ~= nil then 
		self.output_desired = not not state
	else
		self.output_desired = not self.output_desired
	end
end

function BeeMovie:SetLine(n)
	self.current_line = tonumber(n) or self.current_line
end

function BeeMovie:GetLine()
	return self.current_line,self.current_line and self.lines[self.current_line]
end

function BeeMovie:IsPlaying()
	return self.output_desired
end

function BeeMovie:SendChat(text,prepend)
	if managers.chat then 
		if false and managers.network:session() and #managers.network:session()._peers_all <= 1 then  --not necessary
			managers.chat:_receive_message(1,self.prefix,text,Color.yellow)
		else
			managers.chat:send_message(1, managers.network.account:username() or "BARRY",(prepend and self.prefix or "") .. tostring(text))
		end
		return true
	else
		self:Log("ChatManager not found. What were we thinking? Look at us. We're just a couple of bugs in this world.")
	end
end

function BeeMovie:DoOutput()
	if self:IsPlaying() and not self:IsDisabled() then 
		local num,text = self:GetLine()	
		if text then 
			if self:SendChat(text,true) then 
				self:SetLine(num + 1)
			end
			local delayed_calls = DelayedCallsFix or DelayedCalls
			delayed_calls:Add("bee_movie_output",self:GetMessageInterval(), callback(self,self,"DoOutput"))
		else
			--reached the end of the script
			self:SetLine(BeeMovie.starting_line)
			self:Stop()
			self:Log("Did not find valid text. Stopping... You snap out of it!")
		end
	else
		self:Stop()
	end
end

BeeMovie:Load()